/*
 * progress.h -- interface description for PROGRESS.DLL
 * version 1.0, January 1993.
 * Copyright (c) Stephen Crane 1993
 */

// Styles
#define PS_NORMAL	0		// default: a horizontal bar
#define PS_NOCANCEL	1		// hide & disable CANCEL
#define PS_NOPC		2		// hide percentage value
#define PS_PIECHART	4		// pie chart

/*
 * CreateProgress -- Create a new progress meter
 * HWND hparent
 * LONG maxrange
 * LPSTR caption
 * LONG style
 * HBRUSH hfill
 * returns handle to progress meter window
 */
HWND FAR PASCAL CreateProgress (HWND, LONG, LPSTR, LONG, HBRUSH);

/*
 * UpdateProgress -- Update the progress meter
 * HWND hprogress
 * LONG position
 * returns true if the progress meter still exists
 */
BOOL FAR PASCAL UpdateProgress (HWND, LONG);

/*
 * DestroyProgress -- Destroy the progress meter
 * HWND hprogress
 */
void FAR PASCAL DestroyProgress (HWND);

